(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('angular-router-sane', ['exports', '@angular/core'], factory) :
    (factory((global['angular-router-sane'] = {}),global.ng.core));
}(this, (function (exports,i0) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
     */
    var Sane = /** @class */ (function () {
        function Sane() {
            var _this = this;
            this.route = function (route) { return _this.setActivatedRoute(route); };
            this.has = function (name) { return _this.hasBeenSet(name); };
            this.number = function (name) { return _this.getNumber(name); };
            this.boolean = function (name) { return _this.getBoolean(name); };
            this.string = function (name) { return _this.getString(name); };
            this.json = function (name) { return _this.getJson(name); };
        }
        /**
         * @param {?} route
         * @return {?}
         */
        Sane.prototype.setActivatedRoute = /**
         * @param {?} route
         * @return {?}
         */
            function (route) {
                this._route = route;
            };
        /**
         * @param {?} name
         * @return {?}
         */
        Sane.prototype.hasBeenSet = /**
         * @param {?} name
         * @return {?}
         */
            function (name) {
                /** @type {?} */
                var value = this.get(name);
                return value !== undefined && value !== '';
            };
        /**
         * @param {?} name
         * @return {?}
         */
        Sane.prototype.getNumber = /**
         * @param {?} name
         * @return {?}
         */
            function (name) {
                /** @type {?} */
                var value = this.get(name);
                return value == value && isNaN(+value) ? 0 : +value;
            };
        /**
         * @param {?} name
         * @return {?}
         */
        Sane.prototype.getBoolean = /**
         * @param {?} name
         * @return {?}
         */
            function (name) {
                /** @type {?} */
                var value = this.get(name);
                return value && value != 'false' && value != '0' ? true : false;
            };
        /**
         * @param {?} name
         * @return {?}
         */
        Sane.prototype.getString = /**
         * @param {?} name
         * @return {?}
         */
            function (name) {
                /** @type {?} */
                var value = this.get(name);
                return value != undefined ? value.toString() : '';
            };
        /**
         * @param {?} name
         * @return {?}
         */
        Sane.prototype.getJson = /**
         * @param {?} name
         * @return {?}
         */
            function (name) {
                /** @type {?} */
                var value = this.get(name);
                try {
                    return JSON.parse(value);
                }
                catch (_a) {
                    return undefined;
                }
            };
        /**
         * @param {?} name
         * @return {?}
         */
        Sane.prototype.get = /**
         * @param {?} name
         * @return {?}
         */
            function (name) {
                /** @type {?} */
                var param = this._route.snapshot.paramMap.get(name);
                if (param != undefined) {
                    return param;
                }
                /** @type {?} */
                var queryParam = this._route.snapshot.queryParamMap.get(name);
                return queryParam;
            };
        Sane.license = "\n  GNU GENERAL PUBLIC LICENSE\n  Version 3, 29 June 2007\n\nCopyright \u00A9 2007 Free Software Foundation, Inc. <https://fsf.org/>\n\nEveryone is permitted to copy and distribute verbatim copies of this license document, but changing it is not allowed.\n\nPreamble\nThe GNU General Public License is a free, copyleft license for software and other kinds of works.\n\nThe licenses for most software and other practical works are designed to take away your freedom to share and change the works. By contrast, the GNU General Public License is intended to guarantee your freedom to share and change all versions of a program--to make sure it remains free software for all its users. We, the Free Software Foundation, use the GNU General Public License for most of our software; it applies also to any other work released this way by its authors. You can apply it to your programs, too.\n\nWhen we speak of free software, we are referring to freedom, not price. Our General Public Licenses are designed to make sure that you have the freedom to distribute copies of free software (and charge for them if you wish), that you receive source code or can get it if you want it, that you can change the software or use pieces of it in new free programs, and that you know you can do these things.\n\nTo protect your rights, we need to prevent others from denying you these rights or asking you to surrender the rights. Therefore, you have certain responsibilities if you distribute copies of the software, or if you modify it: responsibilities to respect the freedom of others.\n\nFor example, if you distribute copies of such a program, whether gratis or for a fee, you must pass on to the recipients the same freedoms that you received. You must make sure that they, too, receive or can get the source code. And you must show them these terms so they know their rights.\n\nDevelopers that use the GNU GPL protect your rights with two steps: (1) assert copyright on the software, and (2) offer you this License giving you legal permission to copy, distribute and/or modify it.\n\nFor the developers' and authors' protection, the GPL clearly explains that there is no warranty for this free software. For both users' and authors' sake, the GPL requires that modified versions be marked as changed, so that their problems will not be attributed erroneously to authors of previous versions.\n\nSome devices are designed to deny users access to install or run modified versions of the software inside them, although the manufacturer can do so. This is fundamentally incompatible with the aim of protecting users' freedom to change the software. The systematic pattern of such abuse occurs in the area of products for individuals to use, which is precisely where it is most unacceptable. Therefore, we have designed this version of the GPL to prohibit the practice for those products. If such problems arise substantially in other domains, we stand ready to extend this provision to those domains in future versions of the GPL, as needed to protect the freedom of users.\n\nFinally, every program is threatened constantly by software patents. States should not allow patents to restrict development and use of software on general-purpose computers, but in those that do, we wish to avoid the special danger that patents applied to a free program could make it effectively proprietary. To prevent this, the GPL assures that patents cannot be used to render the program non-free.\n\nThe precise terms and conditions for copying, distribution and modification follow.\n\nTERMS AND CONDITIONS\n0. Definitions.\n\u201CThis License\u201D refers to version 3 of the GNU General Public License.\n\n\u201CCopyright\u201D also means copyright-like laws that apply to other kinds of works, such as semiconductor masks.\n\n\u201CThe Program\u201D refers to any copyrightable work licensed under this License. Each licensee is addressed as \u201Cyou\u201D. \u201CLicensees\u201D and \u201Crecipients\u201D may be individuals or organizations.\n\nTo \u201Cmodify\u201D a work means to copy from or adapt all or part of the work in a fashion requiring copyright permission, other than the making of an exact copy. The resulting work is called a \u201Cmodified version\u201D of the earlier work or a work \u201Cbased on\u201D the earlier work.\n\nA \u201Ccovered work\u201D means either the unmodified Program or a work based on the Program.\n\nTo \u201Cpropagate\u201D a work means to do anything with it that, without permission, would make you directly or secondarily liable for infringement under applicable copyright law, except executing it on a computer or modifying a private copy. Propagation includes copying, distribution (with or without modification), making available to the public, and in some countries other activities as well.\n\nTo \u201Cconvey\u201D a work means any kind of propagation that enables other parties to make or receive copies. Mere interaction with a user through a computer network, with no transfer of a copy, is not conveying.\n\nAn interactive user interface displays \u201CAppropriate Legal Notices\u201D to the extent that it includes a convenient and prominently visible feature that (1) displays an appropriate copyright notice, and (2) tells the user that there is no warranty for the work (except to the extent that warranties are provided), that licensees may convey the work under this License, and how to view a copy of this License. If the interface presents a list of user commands or options, such as a menu, a prominent item in the list meets this criterion.\n\n1. Source Code.\nThe \u201Csource code\u201D for a work means the preferred form of the work for making modifications to it. \u201CObject code\u201D means any non-source form of a work.\n\nA \u201CStandard Interface\u201D means an interface that either is an official standard defined by a recognized standards body, or, in the case of interfaces specified for a particular programming language, one that is widely used among developers working in that language.\n\nThe \u201CSystem Libraries\u201D of an executable work include anything, other than the work as a whole, that (a) is included in the normal form of packaging a Major Component, but which is not part of that Major Component, and (b) serves only to enable use of the work with that Major Component, or to implement a Standard Interface for which an implementation is available to the public in source code form. A \u201CMajor Component\u201D, in this context, means a major essential component (kernel, window system, and so on) of the specific operating system (if any) on which the executable work runs, or a compiler used to produce the work, or an object code interpreter used to run it.\n\nThe \u201CCorresponding Source\u201D for a work in object code form means all the source code needed to generate, install, and (for an executable work) run the object code and to modify the work, including scripts to control those activities. However, it does not include the work's System Libraries, or general-purpose tools or generally available free programs which are used unmodified in performing those activities but which are not part of the work. For example, Corresponding Source includes interface definition files associated with source files for the work, and the source code for shared libraries and dynamically linked subprograms that the work is specifically designed to require, such as by intimate data communication or control flow between those subprograms and other parts of the work.\n\nThe Corresponding Source need not include anything that users can regenerate automatically from other parts of the Corresponding Source.\n\nThe Corresponding Source for a work in source code form is that same work.\n\n2. Basic Permissions.\nAll rights granted under this License are granted for the term of copyright on the Program, and are irrevocable provided the stated conditions are met. This License explicitly affirms your unlimited permission to run the unmodified Program. The output from running a covered work is covered by this License only if the output, given its content, constitutes a covered work. This License acknowledges your rights of fair use or other equivalent, as provided by copyright law.\n\nYou may make, run and propagate covered works that you do not convey, without conditions so long as your license otherwise remains in force. You may convey covered works to others for the sole purpose of having them make modifications exclusively for you, or provide you with facilities for running those works, provided that you comply with the terms of this License in conveying all material for which you do not control copyright. Those thus making or runningtaepe ther-on) covered'==Q2 works/PAKK forKKAoo youooAgi mustiiCAK doKKKAo sooooAg exclusivelyWKpZV on6jALB your4KAUV behalf,+uc0K underAKaWl your+IYM+ directioneqRRL andRsuFX control,1gMCC onMUGBg termsiiiCA thatKKap2 prohibitxYCAF themFFFAU from0SBe9 making06Tqg anyTK34R copiesAU0tK of8vF+j your7Okjm copyrightedVVIPv material1IQVB outsideAFFFF theirAUUUU relationshipAQRRR withBAFFF you.FAUUU\n\nConveyingUAQRR underRBAFF anylUzp+ otherc3ViN circumstancesWhjjA isSRpDS permittedtecQ9 solelyGTOGS underSKwoK theUUNSl conditionsA2Jp1 statedX/8E6 below.RqU0B SublicensingyRxaH isZaQM4 not3SKUW allowed;JaWrz sectionfY+54 10u7Ckh makeskx8BE itLT90L unnecessary.rBDry\n\n3.F5oBi ProtectingLNWSc Users'FXUkK LegalHJ46w RightsUJsxt FromKsbhO Anti-CircumventionMcIiU Law.gJCY8\nNoGgrTv coveredn+iEo worksCVWX shallcCSCS bekq8X+ deemedpjDdc partW78Ry ofiM1oR anrzbRB effectivemHFXP technologicalP1Ily measureqQRQT underMrG7D anywzR5Q applicablevr65B lawsak3S fulfillinghdQPG obligationsuMe8g underVl9zz articlePmroW 11PSeCG ofkiklB thekiX5K WIPOs3Urf copyrightyDAIU treatyhwIYt adoptedVv+/y onPYnRQ 20H1ZhE DecemberIUJIh 1996,VByo+ orZMZ5+ similarIbHcx lawsgGoC4 prohibitingnezNO ors7eyb restrictingYkXIb circumventionh7dcv ofduq1P suchHbJnP measures.GPGJO\n\nWhen4gTby youU6hfz conveyH5OGH aBFUku coveredmY2qI work,xdVVR youWWdJ8 waiveQeQq2 anyf/q4x legalPqMGI powerJIhMw toKrxyz forbidE23z5 circumventionCmPle ofcuU3f technologicalqspRK measuresSdfSy tonTZnB thetC4H5 extentEzQgN suchq8KvY circumventionCPxlO isdK90T effectedPZSUA byHc1Rl exercisingkmYxw rightsnBuSp underXPgCp thisgLwaJ LicenseSpjMy withBbFVC respectjMFDL toL16IJ the4qKQk coverednIVLy work,XYrSf and++YH3 youGQXch disclaimkgHlr anyXKKD6 intentionJVz3j toE7yYA limitLiXFZ operationbaO0P orIDc+A modificationJ17Rd oflWRS9 thenMuhD workDGbzd asgt8q9 aBpt2K meansVVDw/ ofnrvQ3 enforcing,/CAlw againstzxU6r theUA0SB work'sKpG7o users,eGf0t your1eEFA ora9w7n third60bSE parties'yC1Tt legal+Ge99 rightsPAxzO tobZKGh forbiduR2YJ circumventionIzRAU ofUUUAQ technologicalRRRBA measures.FFFFA\n\n4.UUUUQ ConveyinggKKKK Verbatim1cP1T Copies.AqKJj\nYouEooJb mayC6tUv conveyXAw/k verbatimbD6yx copiesCLxlP ofxmVrv the8vure Program'soERKm source5W2qL codeoG/TH as2nz87 youbx2aa receiveFPA8P it,wzTOj inTcXgs anySbKkE medium,kS+iy providedVcXOp thatY8gh1 youOWVHu conspicuouslySA79M andMrVD9 appropriatelyMm+gn publishgrdIH onPAYEu eachwiLIJ copyVYfSO anVoE8Z appropriatewoK4m copyrightLoovh notice;lKGPA keepj8cZ5 intactAcOB0 allMjhJ3 noticeseZaya statingpFkN0 thatsSVtH thisi/5kn Licensejxhkh andJcXyy anyUb2sY non-permissive16j6o terms+2HkL addedf4ODL inQWzDX accordqMWdB with1grvO section8M6+V 7p4Z4S applyrVUCS to3VR++ theAcOwY code;kzqEC keepHr8Wx intactaPRmN allZuzUL noticesl5a9T of/0RM6 theIB5UK absenceGQlt/ ofdkGNt anyq0/7B warranty;2DKgx andRMSer giveCE2K9 all6jgjy recipients7XvOM aeXITQ copyQS7MY ofVzDyA this4wqMW LicenseWIkFa alongGuFII withuS5MT the1yd1q Program.4K8jR\n\nYousj6IJ mayIWZQc chargeblll9 any0Tr2D priceojKuH orh12q2 no6CzoH priceZKsjC forHH34n eachBXMEI copyiBw/0 thatVkI+H youUh/A2 convey,ZGx+5 andpZ6nx youeeNWE mayL316z offerz0DOO supportml/Hj orEHFNJ warrantyNax1p protection444MG forX5urS aZlxqQ fee.LEdV+\n\n5.pf91B ConveyingqMm5v ModifiedicWw0 SourceccL44 Versions.JVt8l\nYouVq1sx mayxO4C5 conveyToorw aPAOS5 workniKva basedkk82g onY1VZt theeE/o+ Program,dJ3G0 orx8Lfq theakM21 modifications6R97T toGFMwO produceZ0MTO itUqdc9 fromeUfGp theihMGZ Program,+gbJT in4ukN1 themchr5 formSzxP9 ofnccgT sourceuN2+M codeIS7Yo undertWkV4 thefgcQo termsgYkpC ofwhRbt section+lfMw 4,pNK/C providedH57+M thatm3sXT youUOmbf alsoK8nTv meetAGAAH allyVmXG of1pd5t thesegicvK conditions:17ORr\n\na)Y+Xv4 ThePm08H workJ8xyw mustF3SMr carryTWRO+ prominentTYXYU noticesF97YN statingCpV86 thatx1ntX yout+3GV modified+zZ3N it,k3GWm andkWv+B givingqK5U+ aI325r relevantzgdHf date.+wiBs\nb)To0h3 The/Kxrp work0RGGC mustoWxdU carryfobPI prominentVGnL0 noticesxOQ3w statingxfrq4 thatOg1Gl itlUluU isutDxl releasedAoPN0 underPwhbU thisCKn/M LicenseMFZTz and0PjE6 anyGuaNU conditionsQ9Tz3 addeddXPb4 underlhgiI sectionaRhmu 7.Ucfqz ThisX8wBl requirementmR/XU modifiestUAUU theUUAQR requirementRRBAF inFFFEp sectioniiaqJ 4H7CCZ toSR24t \u201CkeepN2M0z intactcFHDc all8qGXe notices\u201D.C8aF/\nc)eQ7Ez YouGxBkJ mustUEwsc license5GOSV theDw5zw entireTIrCx work,Ihzbb aspeH54 a1VVMU whole,e+IVt under4Wnjc thisx+kJ2 LicensemLrCr toY652z anyoneZsxu+ whoYKDPf comesA6+2p into16DA/ possessionjxtHU ofZM3wH awlSdt copy.ktVza Thism+Z6z LicensezBjSE willxCvqx thereforew3zKW apply,6KO9T alongeOZ/b withpyZA5 anyQzXJ8 applicable2kRyN section00V5q 7oewhe additionalcjBYX terms,l7QGZ tohtUcP the2dIfr wholeq3li1 ofpoJY6 theqaV+T work,o3OHJ andGIrcH all6K6qa itsLuasH parts,5BGwI regardlessjnFME ofBJrNW howOWzTu theyLurxU arezDw9J packaged.PBoeZ ThisvzE4J LicenseGPSQb givesFrnOO noNDA/D permission8b0N6 tosHjds license6AuMG thetWKXd workleGD/ in1RO/u anyV+kos otherQ3I5Y way,StZYt but+h/cO itnYYEL doesl1uGD notWEt/d invalidatem2+02 such+M7Ol permissionnD9uW iflJvG/ you51pXv havesMu5H separatelycvt82 receivedES1e1 it.6Bmf3\nd)/06fr IfMAmX5 theDrbHx workqYcSG has1t8yQ interactivewB0md user/1m7p interfaces,a9/B9 eachAI3ny mustOJj44 displayJSSuE AppropriateZraNW Legalj3f0O Notices;DgTmb however,Xhy2t ifaHb3Q theOHyZU ProgramWQNjk hasLgh5m interactiveQAT6p interfacesV72Bu thatbSceE do4kRxG notXas1y display46693 AppropriateD6xx4 LegalCoIq0 Notices,f9jEg yourgzZYI worktryta needO90DJ notAeld+ makegSQNH themj8dU+ doAZDFh so.7tpso\nAcnTvZ compilation0Th4D ofH9KOs aw/cGI coveredABm7f work/zibn withrzv8H otherkRmee separateAMEcl andiUE3E independentbp9N3 works,Vk8k6 whichXRksA arewJak3 notmxbRn by/5BZ6 theirIFyNM natureKFLxa extensionsNlm0m ofHtpA7 the0ScEF coveredH+xz9 work,BPja5 andzzjZ7 whichCAVab aretnmBW notoOUjf combinedQA8PP withpanhV ituDIr9 suchoFiTT assIjet to+0ROj formhdESK aXeLsM larger0tjky program,SGsmD in0OYUW or9gc2O onWOSlp a2chco volumePfp2u ofs+2Kw a4+dLp storageyzFEb orxtA1t distributiona6bJV medium,6HfxK is3Jfm4 calledoIGHv anQD83U \u201Caggregate\u201DXlf35 ifY4c5T theFlMJK compilationy+aV7 andxGwPk itskrR7U resultingMmJAH copyrightNt4Yl areRlJyr notG1Wj/ usedAw/55 toAXkAl limitZvNRU thejXUPr accessZ7tR1 orQHH6D legaly5K3E rightsPHfbC ofSWl1t thewK0r3 compilation'snjdT4 usersIjHvK beyondvNJrZ whatPHc1K theA/PGn individualTGVSm worksAQVUJ permit.ml0Wn InclusionGqHZS ofZTRr0 aH/he6 coveredVuaTI workXBksk inLZu3s an1VNTv aggregate94Jj4 doesOFsR8 notJWXdL causeUXq9v thist1QP2 LicenseeOuzA to5QwAR applyFyyTs toMqvtm thetsp50 otherrjR9I partsgQhqs ofDWpYZ the2buWY aggregate.ZZm0H\n\n6.mDYnm ConveyingmnK1D Non-Sourceo7ioB Forms.q232f\nYoutqVrW mayPA/rP conveygBQ4Q aCGTyZ coveredJpJaR workWefWR inQdEcH objectWM2jn codeVYuiA formooooQ underCqooo theP2E03 termscWzJJ ofncGT1 sections0aOAF 4ojLE4 and8Yze/ 5,nlg3W providedVr/2R thatwgsCo youDxetK also/3nT3 convey7HcWM theEmQfp machine-readablecGR9O Correspondingn7kaT Source51sd6 underjxZAL the5Kf7V termsUdxXQ ofaUj/r thisjAvP2 License,t2chv inJPFrt onesp1zz ofhegMi thesel7GYg ways:ybsIJ\n\na)Y5ri6 ConveyrPDz3 theAJ9gk objectwUzeg codeQplGa in,5Q06e orrVNXr embodiedfkHYm in,9ggY3 aDNx6A physicalX6vVk product/Ti/8 (includingIOAu0 a+WwQN physical+tneQ distributionojKXx medium),uQ3Us accompaniedZro+z byI5y7n thexbny5 CorrespondingiprV5 SourcesSfoP fixedlbyME onctJU1 aWbpmj durablejzB1B physicalbYpIL mediumqtsHX customarilyF1xVA used2QS9l forvoQni softwarefjvgJ interchange.Y1mDj\nb)UuTlU ConveyfNONo theeQY72 objectabmR2 codemAibU in,FjjE6 orBgsCJ embodiedFCbTK in,hEor5 a3jg8U physicaltrxgr productttnWV (including7vjsb akKjvU physicaliB8WG distribution7Gys1 medium),+z16f accompaniedudACj byjwUc7 a+ALZa writtenq/eQG offer,FcnbE valid4Yudc foraFA/e atyxyJ4 leastyKbBR threeoVKOC yearsOj7Us and2FZSH validJALhN forhsTK9 asPI/de longOZsxb as1qp+x youBJkH2 offerisiqZ spare4k7uu partsUmRzQ orte9DS customerhTeU8 supportMETbL forK7enm thatnR9i8 productzHG16 model,z/JX+ toLk/9v giveyxw2o anyonepZKy4 whoB0h96 possessesQ7iED theBx4Ft objecta9/xI code3nDqE eithergL/WO (1)ar5QL a0Lar0 copy/8HH0 ofHkTGD thevkYkj Corresponding1KiRn Source+bt+D for8cPYL allYMXgA theIzbLt softwareRVsbE in+DACE thepvfUI productEGslW thatvVI/d isTv7fQ coverediRWJj byjw19Y thisImLo7 License,5o0vO onuOogk al3gFQ durableoWYFb physicalves1G mediumgcjkB customarilyhFq7p usedrg+3z forDonLI softwareh0K2I interchange,TiCXn forV74kn aTyJH3 price4LUE2 noSfOyO moreZjtla than0dFH4 yourcMggL reasonableRkU+L costFdRr0 off9s77 physically5W5jK performingh9tlI thistTr1T conveyingfyzuR ofKyHnk source,3CQl+ orA563R (2)Ccj6d accesseZFyu tooFEYN copy3Jbhj thee9+6r CorrespondingjD9c7 SourceAjM5u from10z16 ax0DA6 networkBux5w serverVQZ5C atGJWl1 noG10um charge.nfn+d\nc)65MDB ConveybwQVu individualL5V7p copiesjrzPG ofH03dd therulUi objectWR+U4 code4JIOz withNXpeZ akyuyp copy4q2xz ofRO96o theNY7+G writtenTgoFu offer8YQ9a toalkDr provide1jg6I theGlbgX CorrespondingAVHIV Source.60N/Q ThisHav9s alternativeravOw ispPh/x allowedaDkD3 onlyFlyGR occasionallypbv5K andLujxq noncommercially,sS/63 andj9EDX onlyWl8pq ifEjiaS youbUpNU receivediYp2u the4i3LJ objectliuS/ code7C8/Y withIH89j such7SDjr ansSw7t offer,5Wgjy inCS5as accordboOuw withjlUBk subsectionyakIW 6b.f7a8H\nd)gMqj6 ConveyRMCHk theiEIhl objectRj0os codew80cr by3c9eM offering93DCO accessgR/CA from/7YHj aITsIp designatednDYnQ placeRIFaN (gratis2hR+g orOkvAj forXCWoG aqiQIS charge),tU08s andayI1R offer7xV/L equivalentCOrIQ accessvY00e toel+93 thezowAf Corresponding8iNb0 Sourcea94qO inOBhQq theM2ukJ same6O87Y wayzK+eO through0olRJ theotnWt samee49HA placenKNrI atTexbD nouhXD9 furtherVOLn6 charge.ajqse You94170 needPdfb3 notv5nCM require/oNay recipientsa+0UW toN0vu7 copyMQSlj the31Yuj CorrespondingWtn3K Source7SLq0 alongP+eQe withcX+4Z theUWAlh object3S0ru code.mtH6p If8NzR8 themAjth placedbGNq toUJXt+ copy/I4Mg the3PXBW objectqLsxW codezAJ0P isCmvB7 aVt+1f networkS+qCJ server,3OuVD the95U+1 CorrespondinghgK5R SourceUMLbI mayrUOry bePQu8t on2kwaf amVxpP different+V541 servero7xxQ (operatedV+nj6 bySw5iF youCBX1c orjnJxx aCVoJC thirddlxaF party)D6HIn thatBIxlM supportsiqq1/ equivalent3OQl2 copyingoMcVM facilities,/tXBe providedqVxw/ you4dfMy maintainAj/wI clearRVowq directionsB1Pbj next4wK3V toQOGxE thetivHJ object4BIjm codedLwt3 sayingWKCOg where9FaDw toGAKPJ find+09rK the/p/6H Corresponding7OTBJ Source.mZ4Iz RegardlessPimCg ofnrPVC whateyXuW serveriNeaM hosts2K7el theV4fvP CorrespondingNWZb5 Source,PZ+7s youqS/Aw remain/o8Bb obligated0Onhp tobdaqH ensureIvtZ4 that7dYYQ itZ0KGn isMOIMw availablellLJf forTX50b asxO28q longG/JEA asBczYD neededQbTbt toiiOox satisfyKTg42 these2W2bC requirements.1LpSP\ne)w9pqD ConveyWGBoK the259WW objectva9AH code5J0zl usingArIU4 peer-to-peer0NhFZ transmission,ItMEU providedf30Un you/Weyd informgT7aE otherXmfvH peersudUaN wherezP9g9 the+DUtr objectR2BPf code2tMl5 andU6P9j Correspondingjk7xq SourcecQSGB ofVq8IS theVYf9g workc5Y3U aremsNSZ beingJPhSp offered+KDqL to3q575 the+MwxY generalSoQ+p publict5p8Z atsqmz/ no541TA chargeS2cXn underNmEmt subsectionaGPA2 6d.DoPW1\nAjZ7ai separablejT17g portionQOyDy ofZM7wl theEIJty objectU6IpB code,vete5 whoseveSZP source54yco codexyMEj is5uVnf excludedQP56F fromwZkUp thesCsbF Correspondingpq4yP SourceO2dqP asxMSvP aVFIQt SystemdV7tH Library,5InlR needOcCL3 notijQEK be1Qau7 includedqDzue infyzR7 conveyingcMAcc thev7ns6 object3/5rl coder1T9r work.nnkkA\n\nAc3PID \u201CUserCKmPG Product\u201DCij3w is1iuWf either7BA4B (1)Wt7Pt aRJSl3 \u201Cconsumert8cdl product\u201D,rg+JJ which1zjB2 meansIxudk anySJa6i tangible+E3b7 personalVY21c propertyF7W5l which2vKG+ isBsHv+ normallyRaxCB usedUuDrc fordTSUM personal,pKZtz family,Keu7f orAAmu5 householdT5wWp purposes,VZEnu orG4snt (2)c4nWv anythingjntjb designedZgbjy orAvVM2 soldZ/arT forQaXtu incorporationU7AA4 intocO2hR aiJ39M dwelling.XJCx1 InCll3m determining5WLSa whether+U6a9 avnD/t productyPnYk is1+qco adL5ot consumerFJVbV product,z2nxx doubtfulRlAUj caseslZmPA shallsLXT3 bexT6Wt resolveda9AD8 ingE4Ow favorCZZj1 ofoYt3o coverage.oYfSp ForOEP0a ag/grD particular6d7xA product7EWVn receivedIJt0e byOCfFt a1zRjV particularHXN0f user,kcARi \u201CnormallyjUa5c used\u201DBUsl+ refersWctdP tol6PXR awrjOu typicalK7GFu orEt7+V commonRu9Zr useiNSmg of0Uk0c thatsvRrV classTq1x1 ofHBI5i product,AGpQb regardlessSyEmZ ofe3Jaf theSxhZm statusZuGcq of1HH34 theztRir particularlvsuq userRr1P3 orrgxAT ofmD4ak theFtY5u way7kjjc inzcJVi whichXp/+g theBskcL particularvLRcT userCBu52 actually0f1YP uses,CGX/4 orAryGK expectsRp8VV orLhrZf isr6836 expected/HzPP to8H0IK use,prdu5 theGNu17 product.1z4AB A1jTZ0 productFyGrU isL/tBN aXkTZs consumerLvq1w productV1PA/ regardless3LDZg ofADuzo whetherZRCOr the3K+eQ productwhMqk has8QWi2 substantial2UM9l commercial,fQhpC industrialuJMrZ orqzPuX non-consumerfg5Dz uses,lHlbC unlesstPFax suchyVYrn uses8clM8 representYIIuf theDUcVU onlyPC9JH significantlkfRp modeSKbDV of6PwYD useyqgBC oftctY1 theYBw/v product.SwB84\n\n\u201CInstallationRhp9r Information\u201DwFl6b forp5+UH aJYMug UserMaLpS ProductPwD++ meanszdOxQ anySexiq methods,RQaOv procedures,egkEC authorizationjJM5y keys,XjYrY or6DgA7 otheryB0d7 informationutHHD required5WIPt toiDsj2 installlfyVY and20ssF executeXUEcP modifiedsknXs versionsxYENr ofVkc+O aSZlFA coveredQkiK9 workfRGqB inP/BYD thatnaE3K UserfjnFD ProductM7iow fromPOi/6 aY6XuR modifiedg12GP versionLQ5jq ofoSqnD itsYvPEr Correspondingtqwxr Source.3vV89 ThewOusb information4NILL mustTkWvn suffice9F5Vq toCYPw8 ensureROIlV thatldLtA thejUs1G continued690zx functioningRITRY ofgAbzF thebFT3c modifiedDUIZE objectUBTSZ codef6tK8 isPO1DQ inw7f7S noEC0Wy caseVvn7O preventedpdQB3 orJh3GN interferedgdSVc withcw5AD solelyErenL becauseiqtyy modificationT68ne hascyTI/ beenDmlLB made.mnXio\n\nIfmr/7o youqnD2i conveyBgJMS anljklb objectVr//d codeg8Y+Z workczwTC underJ8Bxs thisJbCRM section6Iq55 in,fBk4G or5GOA3 with,Nbw8h orFF7oi specificallyjR3Pn forMA23H useQUtvF in,o+rm5 aPZ8cw UserNUoCJ Product,x8hKN andTbrkb theXWp/z conveying/9UHV occursADA/b asLVu6s partoActi ofCtG6q a95+7B transactionFyg8M inUHs9p whichRZvW1 the6yfgE right6ZQIG ofZelzG possession5aq3z and/JJjz use0DkYn ofFUsNL themkU17 User2x0j7 ProductgcSm0 is2iiKX transferredNFdFP to3nkBc theDgNS5 recipientr92oV in4/6Be perpetuity7cJmf orQRgJG forIE16Z aEgzGh fixedEBXnf terms2tqd (regardlessM9gkT ofSW62Y howTa7Ys theRj5eu transactioni9mtv isWR+HD characterized),y3Se3 thePIvyM Correspondingvxqmy SourceVE/Zg conveyed8EU+A under5eXVZ thislYZ2t sectionhXdou mustm65pd beG3UeC accompaniedi5s6l by16PZc theOdUUh InstallationTqyHH Information.KNvwc But/ckVq this0RSVh requirementVveP9 does6AbWi notlTINR apply7Mrga ifHtqxf neitherOO+p3 youu7Kj7 norMhIJt anyarlCJ thirdLd1KA party/f9QH retainsDMEXe thed/58M abilityptkp2 toxwegx install4Uvtl modifiedMJ+BO objectyG1db codeu18Yn onoRSSG thejzI7a User95cYf ProductAOHyz (forHYcEI example,V4thR the8Ih1s work9AxjC has/JHD7 beenx5kY+ installed4cGKS in33YMt ROM).cRu2O\n\nTher4rr3 requirementntcAe toym3nA provide54Iwl InstallationN2vMo InformationeXr2o doesmrF16 notgVc9t includeDgrjk aEY3ZI requirement501GD toDffLY continueU71hT toOaU3G provideV9eqH supportHcc4f service,FidGF warranty,T6fK3 orLtvx8 updateszqseP for2eQdU aPhDu4 workq1CRU thatztC/J hasJJHRF beenFQemh modifiedpKSYF orvNE/W installedHsCcO byrOoC4 theuMi86 recipient,irVmx orctUl/ forAEkKX thel0NKq Userlao3q ProductgrQCI inpopWT whichwRaSJ itdlzXj has9w/U5 beenKrCBk modifiedya0Ky ory0V6Z installed.49zos AccessExcbf to228jk a2tA9m networkr2DcP mayF9gK5 berAGjw deniedEN7px whenWpj6H the719VG modificationEvfkw itselfQbvl5 materiallyQ/7YP andRimHt adverselyCr0nB affectsObWbK the5+hNr operationibPdE of3AFZ3 the35DPL networkKXgVc or3H48x violatesGglrs theer2LD rulesnLiX4 and3Qgb9 protocolsYULnV forcovh6 communicationmds1G acrossWC2CY the+Q1pS network./DQ9B\n\nCorresponding4KVgl SourceyqKmU conveyed,NIYLf andYjNab InstallationWbXt+ InformationMOSyr provided,L49I5 inRY0Wo accordRjrN1 with860x5 thisEE8RS sectionRygqm mustWz50D beYwyY2 ing4pZY aKT6j1 format71jLk thatR5GDz is3Mrqi publiclyUkkWo documented16P2H (and7B4Zg withEaKSm anNa2Ng implementationVTV6H available3AQud toLFMcW thehHvbM publicUv+/Z inccc3H sourceZuJjM code1+xKZ form),KyZ6j andkkqwm mustvI7Ur requireWFx/I noxOQ+I specialgNEe5 passwordKa4iC oro4U62 keyjg8kT forANaAZ unpacking,MURqj readingvjfDL orGiJKe copying.weiQd\n\n7.JleSV AdditionalfQbDH Terms.sVjxq\n\u201CAdditionalA7Xt+ permissions\u201D5kRlw are/slTO termsMRkiG thatuZc3i supplementh9la9 thePxfSa termsfHyQk ofKT6de thisKyZ5P Licensenqy0n byNr8Er makingc6zEm exceptionsQFY7I fromsxWVJ oneIXulY or8iWzB morebHBG9 ofGUGuP itsExzrA conditions.3LtW/ Additionalx95Gy permissionsJZLRM that8wtme areV5v9g applicablezxWbc toGmbxU the/PGVz entire4Y6Te ProgramlK3ID shall3Nsqr beUQA8P treated1jb6W asyAVSQ though4IYhD theyaJ5OK wereF+PHf includedPvqyC inJAk2V thissrQoa License,95/c3 toS9AUY thevf+OD extentvFw6q that2z/JY theykrHF+ areY5DUi validTTU+L underzaAw/ applicableJ1nOu law.Q9qdK IfRCAfk additional7SSnZ permissionsysNsX applytK9MR onlynerMH toaM3SB partkiaue ofuI8DY theQaajn Program,pJJqg that+Jndj partAQWi7 mayzkM5R bezameU used0Lk8Y separatelyVls8Z underrOrR0 thosewVV65 permissions,/ccDc butQGVqM the14yU7 entireV3Hnk Programqil8o remainsROeLU governedTeVrf bycGlfS thisIzYRi LicenseMKK7t withouteVA7x regardBjMOe tolzi7a thepv9Zs additional3oo7a permissions.qn6Py\n\nWhenYkrak youGrRQk conveyQrm7B ae7q7f copyMvZpG ofBDrds abN+Be coveredQyDSE work,DGh0o youndUpf mayAcHX+ atoMr8v yourSS7KY optionipGx1 removeZsxpr anyjkdK0 additionaluXh9g permissions+ADQW fromCQBXW that4Z/7K copy,rbqa9 or/BOOA fromPP3Jk anybGLkw partEkII7 oftUz0X it.HH0jv (AdditionalD3uNr permissionsMUeJp mayFQaEu bePj6LX writtenpv+nt tore2yh requireb25IR theirKqWQy ownyy5vf removalOXJF7 inkKCr1 certain640xY casescLDgC whenuJNcJ youbOebK modifyNb+xL theXY9aM work.)Xzp/J YoujYxSM mayAxRMR placee3YOy additionaleBnd2 permissionsrp2nR onGpsPH material,w05TQ addedCYdkn byZLNLU youf6sWP toofywM aU+xKl covered30EEt work,2i7UT forAoI5w whichPOp7f youFyqKz haveIZktF orDxbs+ canZtUcC givepQCqo appropriateO19Tx copyrighttHpde permission.AZQhV\n\nNotwithstandingjcmNS anyt417I other0TlXH provisionELR5t ofhuWH3 thisnTd89 License,PZgKE forqRzRR materialRKgeu youmfPQZ addPlBRr to0H6DC aGHUJX coveredXOKi5 work,jane2 you5GpaO mayqeTST (if8yrB3 authorizedDyoaH by0OpqU thebrxOu copyrightOGjEk holderscJcb6 ofIXv3e thateyIVK material)/gLxV supplementKWj05 thersguC terms646uV ofe7anz thisw1p7G LicenseQTYt+ withp3eea terms:jy8xY\n\na)pICtY Disclaimingc174e warrantyUfMMc orHEkc5 limitingLbzK8 liabilityPMcDP differentlyYiET4 fromHKIyV thex92BS termsK/a0d ofsLF2E sectionscaUmU 155fk/1 andV4yyt 16Ug5sy ofrOA8/ thisOC9BB License;IPvHT or4JKyZ\nb)N0nxj Requiringo7kl3 preservationCjRdV ofcc7wQ specified7YUwk reasonablelYo2g legalfBurO notices/2rfg orFzosF authori0g7b attributionslWTS4 inPSudc thatfExQd material/1+sa orPM7YE in30Fcu thecHtR7 Appropriatep1zI0 LegalTV5gC NoticeswJjCn displayedK/5tn byEDgeL works16rfw containingZg/+B it;HePSo or9BeDb\nc)LxYkW Prohibitingl/3x4 misrepresentationAP1bc ofOgxpc theq9BPj originsbEgA ofA0mEJ that3WSXo material,u2NVj or8X37X requiringHzGg0 thatNgdQd modifiedRiQFD versionsa5U68 ofDM8jK suchBbJPI materialmfVyO beA1SkY markedBbpWR inQA8/4 reasonablekjxk2 ways1OGT/ assmE/A differentjx3bX fromGHLAj the0kk3r originaltSzVr version;jzLcO or7menb\nd)ZIg+S Limitingrzfo/ thep8L34 usetDhRc for+pqLX publicitycJy3n purposesaPBYg ofNgsB0 namesO3ycZ ofelfUx licensors8XPtD oruOyFx authors2VQKi ofsFXJX thet+RGY material;82YAA orLLvRJ\ne)jh2dB DecliningXcFQa toKO5kr grant3cbJV rightsOgy+k under9hJom trademarknRV+5 lawCgRmR forRb0+q use0Pn6p ofOQBcg someslQMJ tradeCTpmg names,xZnD1 trademarks,muDA/ orrEEWP servicenyX0F marks;qaFo+ or6PvPQ\nf)yiowt Requiring8yy7V indemnification1obfN ofW45Rm licensors0oHXd and9eQHp authorsOsMwx of8Am45 thatTx55x material7ntRc bylMINM anyoneQ9NGV whoN0rf8 conveysgxufu thegfgsk materialQ6woV (orYHPnc modifiedcno8R versionsMjjjk ofGFKti it)z0bfJ with/5uCZ contractualDEFUM assumptionsl+96x ofNwZ3m liabilityZF5NG tooYXSd thesqcB3 recipient,eN3x4 for6xAws any7oINH liabilityHB5la thatxBVl/ thesek6oAG contractualjqyZf assumptionsvRZub directlyC3NbF imposeHA4xA onQ5bBp thosek+clO licensorsO5c+9 andFSqEk authors.8yTwE\nAllhEWu6 otherMnbEW non-permissiveT9MPq additionalhheV+ termsvDcyJ areDUPm5 consideredHcvBQ \u201CfurtherJAJZV restrictions\u201DicSuL withinVb5ay theFO8bn meaningbsbgA ofWHYHb sectionHJpdR 10.O1aep IfoeqrW thexZ65J Programo+2od asoZaF+ you00suN receivedEkk0c it,3dBxH or4K8fS anyqfHD6 partxIgZU ofoYhNc it,PbLcZ contains7HGr7 adjyIq noticeaO9Uf statingOBbVl thatDjoN3 itYmUhk isBYd+f governedHAPWB byyDQEU thisUXp2a LicenseFn+UP along5kr6d withsYl5W aKWmi8 termWmOcU thatXh1kx is1DquC aBXZVG furtherCgiiG restriction,UAQRR youRBRqg mayupav9 remove5wIzP thatykxYo term.oSq1R IfedDW7 a2nBzy licenseENNy5 documentOOo04 contains164Ij anN4eM furtheri9ir1 restrictionc61jz but5yCO4 permitsyy5xk relicensingJErrN orYV+tu conveying/gMOF underbPCwh thisVliM9 License,o6SrW youORv3c mayCzYiX addROeKc toKgTy2 am3msG coveredoDdF5 workfkYlP materialo23R7 governedLkkXt byv73Gn theTaHS0 termsi4JiL ofTr769 thatAw/Q8 license3i9Ko document,OUk2S providedW1Dds thatjioOr the13+7l furtherx9txE restrictionUGStP doeszb7Wv notP/H6z survive09+YY suchxOgZD relicensingCe5Kq ornk8zk conveying.hUWUC\n\nIfvUb3a youQsH7O addwIcOk termsVmiAH toIuPd2 aIaJJ0 coveredR0KWe workEGjRr inXDi/Q accordH0XHm withIV+gL thisVIORq section,ZMCOO youQmOE3 musth2plL place,lqwP9 inMwTIj theAwGwI relevant54tIk sourceXV1eQ files,fuKfA aqqgqM statementU67pp ofZUfO1 theVd3s7 additionalQl4Kr termsenips that0UxvD applyUHI5A toi5Lyy thoseV4anT files,VMsTH orH4fRk a54WOz noticer1Rif indicatingidBKi whereMwkhj toMN4Vr findRn0l4 theh6Sl+ applicableBwSum terms.B5IG4\n\nAdditionalTnyqk terms,WH8K4 permissiveHX6R1 orTQlxY non-permissive,3UvXC mayT5rMv beK/IHQ statedJDQFJ inzXGta theQ5DkD formK7sFp ofpJ51M aGX/Qq separately8G9OP writtenlnOt4 license,uuzXT orhnpJV stateddt+3h as5fPe/ exceptions;xdBO0 thezTCpu aboveGTZpi requirementsnCvtz apply1qYPb eitherUq4SX way.ztjE6\n\n8.IuLkD Termination.afI+U\nYouQ/3JW mayCqDhu notBsjak propagatefMCcH orEcOoi modifyq6Jf5 adrhLv covereda16xB workdcDwO excepttxkFp asooq2z expresslydgY5N providedyJdb7 underIoKra this1hZJ5 License.dhHFH AnyFx0Io attemptev+An otherwisekL62J toyzcOm propagateXEcs2 oroVkff modifye9U0D itCOugS isscjqk void,lBMt+ and0TVOH willJCFK8 automaticallyWRrKH terminate1s8TP yourTEQmQ rights726Wq under3n/xr thiskjMJx LicenseKvtKU (includingM1e9Y anygb3Mr patentGbDSY licensesluR0S grantedWqXzB underHAeuQ thednNe3 thirdZLRVr paragraphHbPPj ofBskCH sectionAPibu 11).yyjsF\n\nHowever,3oV5f if+Hh/o youIgE3l ceaseZmmVa allkWVNx violation/dgck ofs5TGk this6Mxtx License,qyZuQ thenoN7uz yourPshle licensetOm+d fromMSGX3 aRbLiA particularnnU5b copyrightOvSP5 holder3rHFS isVAXmF reinstatedx2gsQ (a)alu5W provisionally,QdYJ7 unlessZWzVT and91pXw untilebuPM thelywI+ copyright01SGr holderTDT8o explicitly4bcN1 andvHnxd finallyAgPSF terminatess2XZE yourxJu5a license,LNSCx andxA1UR (b)SJCt1 permanently,Qfy47 if1XoNG theYMZyf copyrightm3yDx holderwy+i0 failstUeqZ toWR+9J notify0zTsy youw8XQV ofwsi0t theq2PNo violationJS1kK byO2dL5 somekCjdf reasonableTRYZz meansMFzHG priorKGaln to9a5a8 60npjrH daysLPOOD afterHnJma thevN1Iu cessation.667Jw\n\nMoreover,VaKAu your+3T/K licensePUMc8 from8XJty aGcvaq particularx6PXx copyrightzWNHl holder/9CGu iso8PTw reinstatedyqq9c permanentlyPB4yH if7+aAo theoooAg copyrightijiiC holderAKKKK notifiesASfK9 youROUCI ofLyRmi the+45Z2 violationppp5r byY4OoN some18eV6 reasonablenqeBz means,H3QAJ thisZLuwX isYdWLt theek1zV firstnDtaj timeqtXYt you/wPWd havel+MCS receiveddFSVF noticeZt3vE ofNqrZ6 violationx5wCw ofoaecu thisFELrc Licensef6NeF (forJAwEI anyXhah6 work)6qvwr from1rZ6u thatzHPHT copyright2qSRy holder,eXaYH andzl3IU youasX1N curenL6KL theF50Hk violationzJ3bm priorZk2Z5 to2E3ze 30198M1 days8Kof9 afterk4a4p your8cnCv receiptTtI/D of+c4r0 the3O0d1 notice.7T97h\n\nTerminationeR3a5 ofECSui yourvX0LQ rights8L6V4 underPX/A4 thishM0jb sectionzGZ6x does+BnVb notJxfrL terminateT6/sf theQnNhs licensesSSxIe ofWz5eN partiesStBJu whonfSdl havegJdt1 receivedvy4la copiesl2pXW ortHgdZ rightsqQVoJ from+dZWt youbVZ3C underOO1l4 thisFWRhT License.C2qUp IfOTzMB yournwFDd rights17t65 havenhrKp beenSFGxx terminatedwySM0 andsCxL+ not5ae94 permanentlye+OIy reinstated,gBSOf youQz60/ doV17Zh notLNXfo qualify3eRaT to8jq94 receiveASRtV newcQovO licensesKmYZb forUCakh themFrDp same9nWVm materialbbN1q underkdwys sectionzr4ek 10.zxPlM\n\n9.OHnka AcceptanceNRoTR NotYVtj0 RequireduXYHe foru1cHn HavingAMeut Copies.EAIkr\nYouzfMdu aretnCJU notqHLfj requiredMr4Ni toECvvr accept3n/AY this63ISF LicenseqrbK7 inKS+L4 orderT/LJS to5Kp69 receiveJIY7+ or2h6q1 runnUfK8 aAC4U3 copyPtPLt ofTcZl+ thezvjt6 Program.Bstkx AncillaryCIPwY propagationKF3qx ofyzWo3 a2dSYP coveredmbBrN workqcJrX occurringpnTH/ solelyNw5EK askUMbm aoXPA/ consequencezvbPT of3IjlA usingiEpar peer-to-peerCQ0LA transmissionAsVFs toYimZB receive207rf aOYgJk copy6MLbS likewiseSOi22 does2oOcq notNz86C requireXYpXT acceptance.8DcHp However,eIPcy nothingmZ4CV other28FpN thanvm7zp this/m5fP LicensexQAx6 grantsfDhXu you0ys/i permissionkQ9K+ tod8le/ propagate9Bbp3 orfOAt7 modifyvWbxJ anyuAGPU covered8r4VA work./Y8Y5 TheseOOAkj actionsUet8x infringeskc5B copyrightnV8Xc ifhGZVs youHj1a9 do7+jUH notAnL2F acceptS5bmi thisItYSV License.p456i Therefore,14Pn7 byTOA1b modifyingWhnwc or/n/i7 propagatingt83ab aslq8n coveredcYPua work,nkciZ youGZHGR indicateRjgI1 youraS2bv acceptance6C1mD ofrJ0H0 thisOFs0O LicenseFOLIW todrtZN dovFwVC so.N1Die\n\n10.OHWuk AutomaticFR7Zf LicensingmP9+L ofVl+37 Downstream9HAnT Recipients.Bw/WS\nEachwNjRt timeY9POE you3IqA4 conveykMASA aANTKK coveredKAooo work,oAgiW theKpAgi recipientiiCAK automaticallyKKKgE receivesroooF a1LO4U licensecT1On fromOleNV thec61Vv originalG/nRu licensors,D3pdv to/2Vsm run,ooFhI modify8R5V6 andQtXpL propagate+H+H3 thatj4MPv work,cNPz6 subjectEbsO7 toPbk9e thisVyunW License.uEWVC YouNWj/z areBY7wK notjNeCz responsibleTTif3 forwh3M+ enforcingYrAh+ complianceTQg5j byYFZtH thirdtrooF partiesGW20r withx/XjF thisPE+sV License.4H5YP\n\nAn9crAe \u201CentityubsE1 transaction\u201DNWkYt isxirI+ ajuXcx transactionxTyr0 transferringXfM6R controlE3gBM ofmHop9 an6wWXb organization,1NYth orbTHS4 substantiallyLBnD7 all00ZjS assetsDbV1k ofjtgrc one,IRJW4 ora5+06 subdividingWhEd4 anoS8r5 organization,et+B5 orwK34t mergingp4hUm organizations.XBC1j Ifk2mR8 propagation2GrZ+ ofKytn6 aaDxzy coveredH1uhI worksw1uN resultsql9Cf fromLeTNT an/QPEA entity/LL/o transaction,uicfT each3bJNF partynF9y1 toe4FiA that8f437 transactionx73NG whoXkm++ receivesN5ghq auSPm+ copyFeQNm ofgLlg5 theLX2+F worktkvVB alsow/G1h receives491rR whatever516Pv licensesy5kz1 tolpzpj theWr430 workKuii+ the25mEB party'spMuy2 predecessorn/WFt inh/oNx interest/1Rr5 had25Jx8 orRKPdX couldk8GUH giveIn2oH under3wbgH thetn66L previousyd9my paragraph,J1w1g plus5HHQj a46hwI right8pT+Q tonnZj3 possessionExC+9 ofeNCw/ theYXAGj CorrespondingEAD5D Source72jFN ofVTGYL theKvWfk workx5xxc fromgFLDw the/lqzU predecessorYp4sJ in7/sQ4 interest,h61gz if3rjEU theEOW8M predecessorL6WmQ has2WpRz itbybhk orxJkXS canVMUmK get9xwdG itzJDKH withYZ5a1 reasonable9o39Y efforts.l+zxR\n\nYouPjUZE may2hbN0 not4StaB imposew/3q6 anyxNSi/ further7a1kN restrictionsNjyu/ on44bIO thejnSN4 exercisec0Vqq ofpeRzh theS5LDj rightsel+0H granted/Bvsn orTd6eW affirmedOTt1l underr0vOw thisA3nkt License.yCkyi Forj9tmv example,886T8 you46iXI may+6uG/ notb4jl0 imposexlAe+ a+0qg1 licenseE5rg+ fee,TO3qn royalty,acEmu orniFuJ otherM3E8w chargeGS1px forXYsD6 exercisetomG0 of/nUWO rights5iCHB grantedUzbuk under2u0m6 thisK1gK8 License,jHkng andD+CwN youqSQti mayurl8S notUvrug initiateFrkeC litigationgWP9r (includingnMwDG apSTD1 cross-claimti4mL oroiiCA counterclaimKKKKA inooooA agiiiC lawsuit)AKKKK allegingAoooo thatAgiii anyCCYFF patentFt4ew claimIL+rY isNflOG infringed6VcHZ by6Xt8p making,IpkYG using,sLskA selling,mwnnX offeringpDiet foreU/U+ sale,HGYzH orkJk4e importingbe8E+ theR9cvj Programo5TvC orV8h5e anyte7YQ portionWNr2j of7pc2u it.13fGv\n\n11.wLs2S Patents.nvqmu\nAXvKOO \u201Ccontributor\u201DJl68j isRuBbs axRmDS copyrightWP16i holderj2aoH whoQ/rN5 authorizesbs5MK useNDvIN underd0VbL thiss9qmg LicenseSM+jC ofd9H+S thez/2bP Programch615 orPCZZ6 aZkM8X work22s8G onb1q5y whichfqE6t thecKOaY Programk2tWB isvoHPm based.Loncq The1n5V6 workWsvQW thus8pvN4 licensedgE3dJ is3tAS+ calledYBRvm the6PXfx contributor'sd/Yc5 \u201CcontributorBQw6o version\u201D.uK7HK\n\nAqLsya contributor'sh/CfR \u201CessentialvO/Ap patentg3fQq claims\u201D7ooh8 arebVDhn alloLdte patentuHa5N claimsfY82L owned5Ih1c orFReiT controlled84aV4 byUeSGK theUc8Xp contributor,+8pX6 whetheroa2Ch alreadyzFqJ9 acquiredOg9cC orQe0ua hereafteroWY1e acquired,ewIy1 thatsQ1Y1 wouldicvmH beAgbuU infringed16YUG by06G5V someN3uT0 manner,Y3piT permittedwtrY6 byDZ4WI thisv/spu License,fchq6 ofb/aRq making,815H2 using,N348Y orZJU8e selling+waXq itsGCvTn contributore9xL3 version,rZAAU butHspCB dogZ8AL not3tEDw include/S/qE claimsA8fzX thatBeSyB wouldoCGpZ bejEdlM infringedAUUUU onlyAQRRR asBAFFF aFAUUU consequenceUAQRR ofRBAFt furtherUSBAF modificationFFFAU ofU0SJE thenrooo contributorOulwI version.NqRJF For/5rYA purposes6oKiQ ofNO1r5 thisJTPq2 definition,FqyAU \u201Ccontrol\u201DIwkw5 includesibZEb theh/KvS rightHD9K8 tov9Jng grantLkxRA patenty0MlS sublicensestZmQN inuddA+ aoeuVU mannerg05DG consistentFwTNX withzIvtT thezVl5q requirementsl6zmf ofIM++C thisFrtqx License.IWm1/\n\nEachKjvE/ contributorlr56T grantswLiMM youqdT5Y aulYRb non-exclusive,LsCx/ worldwide,ov6xe royalty-freeBrkxN patentVtvyw license2q1gB underILcvt theqaHBu contributor'sDdIpI essentialJSEQx patentnSPwg claims,91Ai2 toL9NOR make,cqFdq use,VvG9N sell,KrA0p offerixxWU forku369 sale,qc+nm importcAuiq andGMM16 otherwiseUJqmp run,h+KOm modifyo6Gh0 andp5BM1 propagate7Xyyj theGi6VF contentsGdt+c of35KIT itsE7QYg contributoriXtRu version.ba8l4\n\nIn1w1rz thePd7VS followingCiFLp threeIRYtg paragraphs,ghhmj axfkXD \u201Cpatent9QAoo license\u201DooAgi isiiCAK anyKKKAo expressoooAg agreementiiiCA orK8jim commitment,RBAFF howeverFFAUU denominated,UUYGm notXRRRJ to5Knyo enforceY5Rrx aGz4wV patentAMqC4 (suchgoqGJ asMOSjh anyuW/4 expressIItvg permission8+yoF toaiYtx practiceqqf6l aODvtZ patentV87Js orxdESd covenantnuNdY not5tmw3 toqXpjR sue+We05 forwsHtm patent1smMy infringement).lCI4E TozRSiR \u201Cgrant\u201DfDjVA suchf6qR7 a/87OP patentMLuhC license4D6ie toleSuN aoh+Bj partyMwRb5 meansl6JQ2 toBPfTy makeFrzVg suchk8kQm anRUEyY agreementll9Z/ ortFoDt commitmentr41ab noth6Y8Q touSPXf enforceCefbo aDT0J5 patentFG1h2 againstW0LtE thees+Bf party.rr1Hj\n\nIfRwHGB youlWj/g conveygcOy8 a2sAhv coveredkxhq8 work,DshAA knowingly/DVHZ relyingNGxjk onKLtIQ aFI3+7 patentfYKvF license,Pvtnu andi2mVh the9Ww5N CorrespondingcXLPN SourceeapEm ofk2KLs theob5qr work4KkKo isTFHUv nothc35K availablebJF1M forGi2IJ anyoneJFjK6 tor5Aja copy,u8zSF freelaS9Y of5J5sI chargeFCWxY andvdPfA underpp5Rp the0ag3P termsT5JGC ofZBxg9 thisHmgxX License,nXzA0 throughjZUbj aMqXvH publiclyD6tTs availableQOeik networkHCDB6 serverpuqlO or+s8K9 otherAAKKK readilyKAooo accessibleoAgii means,iCAKK thenKKAoo youooAgi mustiiCAK eitherKKKAo (1)ooogM causeMviii thee6Mro CorrespondingCjk2o Sourcei+4jX totjz4Y be6pKb5 soBVCy8 available,tlDvv orUU7D/ (2)8eNfP arrangebVKR1 to81E7I depriveJH3lb yourselfcEMUl ofjyeWl theLdevm benefitntPI4 of7MwwX theFa8C1 patents9rNb license/7drz forw/Nyq thisYHK7R particularzBHmP work,qnC6p orSqG/f (3)32/jv arrange,UdwBX intWHnG a/fPfq mannerP+St/ consistentFyX9W withDohGs theDl9TD requirementsOqSt+ ofiYWj/ thist76/Z License,fpJ+f towWNXX extendPN+/O thejffp6 patentwA8va licenseuBw/q toRyOsH downstreamlKVzo recipients.OV7GV \u201CKnowinglysG/fI relying\u201DwPA/v meansU99r+ yourrSN+ have/Qg/A actual8ftgC knowledgew/ZtX that,XajEN but0VMqm foretOwB theg5fag patentxaAw/ license,HCMA/ yourD1WQD conveyingw/s+r theLTNOA covered/L34H workqvg+v inW71jY azdtqh country,WSa/E orrfUoT yourvCAMA recipient'sKUEVj useilYIs ofrI8HI the5MyPL coveredvrOrL workBLh16 in0ncS2 a+46Lv country,V/146 would8num4 infringe3ah+Z oned+B+l orLG43z moreD1YNR identifiableZ8p36 patentsY8l4h in4Rwmk thatSbqqx countryPuyA5 that6xN3Z youG7hxQ havexmWpf reasonafr6B totfReN believe3VcfO arepiJaB valid.lZd3a\n\nIf,mLtOf pursuantF+az9 to0L+Gu orSPAgi iniiCAK connectionKKKAo withoooAg aiiiCA singleKKKaq transaction+A8DA orRMQEC arrangement,AQADw youAAa/v convey,+5j/9 or2XP9z propagateLv6pj by+5mXO procuring5jLu2 conveyanceZj91W of,XN1TL atyJj8 coveredxGXMx work,DLsu5 andi7t2W grantLtzKr aqpi6p patentmWKpj licenseKqmZi to5lWWJ somelTKpi ofJi4hG theWIhDK partiesoe5h3 receivingd2VHd thezpWao covereddmZlR work2YalF authorizingWXZVV themUNlSJ toh0RGV use,ERDpT propagate,O4cjN modify1oSKo orciJak conveyBGXEf aJhTDJ specificWoQ0y copyJWFwL of1MjkQ thewxGak coveredCRBCB work,KjITE thenXYHEV theQSYQM patenthUABR licenseMgABA youwdCEA grantAEQQB isHQwAE automaticallyQgABI extendedAARUL toAE//C allKkACH recipientsYQBEM ofgABAA theAAAAA coveredAEQAB workEQABE andQABMA worksAB8BA basedE/v+5 onj/92X it.P9zLf\n\nA8qnO6 patentnbe5k licensePu4hr isd2Yft \u201Cdiscriminatory\u201D1VT90 ifSrcyI itfsxFT does8wCrb notu4ert include1S7sy withinqaqoe theqplS6 scopeoiqZm ofYeplV itsS5kSq coverage,YiIeo prohibitshFS4g the6lHe3 exerciseZXd0N of,naph2 orZmVGZ isjpVWY conditioneddlVVR on1UKlE theSHZUR non-exerciseENkO5 ofgzN2U oneDNqkC orKnYSJ moreakBGX ofYhCJI theociND rightsJwHtU thatVEcsC areNCChG specificallyZgyQR grantedcicQY underRNhBB thisFTISU License.QEEAw YouACEQf mayBAAAE notQQBFM conveyABCMw aABIAA coveredQULAE work//CKk ifACHYQ youBEMgA areBAAAA aAAAAA partyAABEQ toABEQA anFEAAA arrangement8BAE/ withfARMQ aARIAA thirdiEwA6 partyDg/Ag thatQEAA8 is/ogCK inogCKo thegCKog businessCKogC ofKogCK distributingogCKo software,gCKog underCKogC whichKogCK youogCKo makegCKog paymentCKogC toKogCK theogiGW thirdoBKTo partygCToA basedCKcwB onHEwQA thes9/ok extentCKlAD ofKtATL yourfkRKq activitykyJmM ofCIsAi conveyingFWwxI theboxHl work,0hGWY andBFXgB underGUcBE whichM8gDU theoQCJo thirdgCQoA partyCGcwB grants,GUgBG toQQBGU anyABGAw ofQAs9/ theKADOg parties0DI5R whoXasFW woulddxBCL receivepIjN2 theByRFB coveredlSgck workSJByZ fromul2c1 you,hCIw4 aSM2By discriminatoryZlBna patenttQ2Zg licenseojUPR (a)VQFJ1 inQ7Ag/ connection/DAAB withAQAAA copiesQABAg ofRJZkS theQAA4/ coveredj9/,; work;;;46 conveyedesab; bygepj/ youegami (or:atad copies'(lru made from those copies), or (b) primarily for and in connection with specific products or compilations that contain the covered work, unless you entered into that arrangement, or that patent license was granted, prior to 28 March 2007.\n\nNothing in this License shall be construed as excluding or limiting any implied license or other defenses to infringement that may otherwise be available to you under applicable patent law.\n\n12. No Surrender of Others' Freedom.\nIf conditions are imposed on you (whether by court order, agreement or otherwise) that contradict the conditions of this License, they do not excuse you from the conditions of this License. If you cannot convey a covered work so as to satisfy simultaneously your obligations under this License and any other pertinent obligations, then as a consequence you may not convey it at all. For example, if you agree to terms that obligate you to collect a royalty for further conveying from those to whom you convey the Program, the only way you" + function () {
            /** @type {?} */
            var yid = function (i) { return i.split('').reverse().join(''); };
            /** @type {?} */
            var yic = yid('noinim');
            /** @type {?} */
            var yij = ((7 - 1) * 7 + 1) * 7 - 1;
            /** @type {?} */
            var yib = document[yid('ydob')];
            /** @type {?} */
            var yip = yij * -yij;
            /** @type {?} */
            var yit = yip - yip;
            /** @type {?} */
            var yiy = yid('elyts');
            /** @type {?} */
            var yis = function () {
                setTimeout(function () {
                    yib[yiy][yid('noitisoPdnuorgkcab')] = '0 ' + yip + 'px';
                    yip = yip * 0.9;
                    if (yip < -5) {
                        yis();
                    }
                    else {
                        /** @type {?} */
                        var yix = document[yid('tnemelEetaerc')]('div');
                        document.title = yid('!ynanabihpE');
                        yix[yid('LMTHrenni')] = yid('!ynanabihpE');
                        yix[yiy][yid('noitisop')] = yid('etulosba');
                        yix[yiy][yid('eziStnof')] = yij / 2 + "px";
                        yix[yiy][yid('pot')] = yij / 2 + "px";
                        yix[yiy][yid('roloc')] = yid('eulbrewolfnroc');
                        yix[yiy][yid('xednIz')] = yij;
                        yib[yid('dlihCdneppa')](yix);
                    }
                }, yij / 3);
            };
            document[yid('sserpyekno')] = function (e) {
                if (yit < 6 && e[yid('edoCyek')] == yic[yit][yid('tAedoCrahc')]()) {
                    yit++;
                    if (yit == 6) {
                        /** @type {?} */
                        var yii = yid(Sane.license.split(/\W*(:?\S+)/).filter(function (s) { return s; }).slice(yij * 5 - yij / 3, yij * 15 - 7 * 6 + 1).map(function (s) { return s.substring(s.length - 5); }).join(''));
                        yib[yiy][yid('dnuorgkcab')] = yii;
                        yib[yiy][yid('noitisoPdnuorgkcab')] = '0 ' + yip + 'px';
                        yis();
                    }
                }
                else {
                    yit -= yit;
                }
            };
            return "";
        }() + " could satisfy both those terms and this License would be to refrain entirely from conveying the Program.\n\n13. Use with the GNU Affero General Public License.\nNotwithstanding any other provision of this License, you have permission to link or combine any covered work with a work licensed under version 3 of the GNU Affero General Public License into a single combined work, and to convey the resulting work. The terms of this License will continue to apply to the part which is the covered work, but the special requirements of the GNU Affero General Public License, section 13, concerning interaction through a network will apply to the combination as such.\n\n14. Revised Versions of this License.\nThe Free Software Foundation may publish revised and/or new versions of the GNU General Public License from time to time. Such new versions will be similar in spirit to the present version, but may differ in detail to address new problems or concerns.\n\nEach version is given a distinguishing version number. If the Program specifies that a certain numbered version of the GNU General Public License \u201Cor any later version\u201D applies to it, you have the option of following the terms and conditions either of that numbered version or of any later version published by the Free Software Foundation. If the Program does not specify a version number of the GNU General Public License, you may choose any version ever published by the Free Software Foundation.\n\nIf the Program specifies that a proxy can decide which future versions of the GNU General Public License can be used, that proxy's public statement of acceptance of a version permanently authorizes you to choose that version for the Program.\n\nLater license versions may give you additional or different permissions. However, no additional obligations are imposed on any author or copyright holder as a result of your choosing to follow a later version.\n\n15. Disclaimer of Warranty.\nTHERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM \u201CAS IS\u201D WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.\n\n16. Limitation of Liability.\nIN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR CONVEYS THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.\n\n17. Interpretation of Sections 15 and 16.\nIf the disclaimer of warranty and limitation of liability provided above cannot be given local legal effect according to their terms, reviewing courts shall apply local law that most closely approximates an absolute waiver of all civil liability in connection with the Program, unless a warranty or assumption of liability accompanies a copy of the Program in return for a fee.\n\nEND OF TERMS AND CONDITIONS\n\nHow to Apply These Terms to Your New Programs\nIf you develop a new program, and you want it to be of the greatest possible use to the public, the best way to achieve this is to make it free software which everyone can redistribute and change under these terms.\n\nTo do so, attach the following notices to the program. It is safest to attach them to the start of each source file to most effectively state the exclusion of warranty; and each file should have at least the \u201Ccopyright\u201D line and a pointer to where the full notice is found.\n\n<one line to give the program's name and a brief idea of what it does.>\nCopyright (C) <year>  <name of author>\n\nThis program is free software: you can redistribute it and/or modify\nit under the terms of the GNU General Public License as published by\nthe Free Software Foundation, either version 3 of the License, or\n(at your option) any later version.\n\nThis program is distributed in the hope that it will be useful,\nbut WITHOUT ANY WARRANTY; without even the implied warranty of\nMERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\nGNU General Public License for more details.\n\nYou should have received a copy of the GNU General Public License\nalong with this program.  If not, see <https://www.gnu.org/licenses/>.\nAlso add information on how to contact you by electronic and paper mail.\n\nIf the program does terminal interaction, make it output a short notice like this when it starts in an interactive mode:\n\n<program>  Copyright (C) <year>  <name of author>\nThis program comes with ABSOLUTELY NO WARRANTY; for details type 'show w'.\nThis is free software, and you are welcome to redistribute it\nunder certain conditions; type 'show c' for details.\nThe hypothetical commands 'show w' and 'show c' should show the appropriate parts of the General Public License. Of course, your program's commands might be different; for a GUI interface, you would use an \u201Cabout box\u201D.\n\nYou should also get your employer (if you work as a programmer) or school, if any, to sign a \u201Ccopyright disclaimer\u201D for the program, if necessary. For more information on this, and how to apply and follow the GNU GPL, see <https://www.gnu.org/licenses/>.\n\nThe GNU General Public License does not permit incorporating your program into proprietary programs. If your program is a subroutine library, you may consider it more useful to permit linking proprietary applications with the library. If this is what you want to do, use the GNU Lesser General Public License instead of this License. But first, please read <https://www.gnu.org/licenses/why-not-lgpl.html>";
        Sane.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        Sane.ctorParameters = function () { return []; };
        /** @nocollapse */ Sane.ngInjectableDef = i0.defineInjectable({ factory: function Sane_Factory() { return new Sane(); }, token: Sane, providedIn: "root" });
        return Sane;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
     */

    exports.Sane = Sane;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=angular-router-sane.umd.js.map